using System;
using System.Text; //Para poder utilizar las clases descendientes de Encoding

namespace ej1_encoding
{
	/// <summary>
	/// Descripcin breve de Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// Punto de entrada principal de la aplicacin.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			//
			// TODO: agregar aqu cdigo para iniciar la aplicacin
			//
			int i;

			// Se crea un String que contenga caracteres Unicode
			String CadenaUnicode = "abc  ";
			Console.Write("Cadena original: ");
			Console.WriteLine(CadenaUnicode);
			Console.Read();
			
			//A partir de aqu se crean las codificaciones
			ASCIIEncoding AE = new ASCIIEncoding();
			UTF8Encoding U8E = new UTF8Encoding();

			//Se codifica el String Unicode
			Byte [] BytesASCII = AE.GetBytes(CadenaUnicode);
			Console.WriteLine();
			Console.Write("Bytes ASCII = ");
			for (i=0; i<BytesASCII.Length; i++) 
				Console.Write("{0}",BytesASCII[i]);
			Console.WriteLine();
  
			Byte [] BytesUTF8 = U8E.GetBytes(CadenaUnicode);
			Console.WriteLine();
			Console.Write("Bytes UTF8 = ");
			for (i=0; i<BytesUTF8.Length; i++) 
				Console.Write("{0}",BytesUTF8[i]);
			Console.WriteLine("\n\nPresiona ENTER para continuar");
			Console.Read();Console.Read();

			  // Descodificar los arrays de bytes
			String CadenaDeASCII = AE.GetString(BytesASCII);
			Console.Write("\nDescodificacion de bytes ASCII: ");
			Console.WriteLine(CadenaDeASCII);

			String CadenaDeUTF8 = U8E.GetString(BytesUTF8);
			Console.Write("Descodificacion de bytes UTF8: ");
			Console.WriteLine(CadenaDeUTF8);

			// Creacion a-priori de buffers de bytes
			String CadenaTexto = "Cadena de prueba";
			Byte [] Bufer1 = new Byte[100]; // Estilo usando tipos .NET
			

			// Uso directo del metodo GetBytes sin crear un objeto
			Bufer1 = System.Text.Encoding.ASCII.GetBytes(CadenaTexto);
			Console.Write("Bufer1 = ");
			for (i=0; i<Bufer1.Length; i++) 
				Console.Write("{0}",Bufer1[i]);
			Console.WriteLine();

			// Creacion on-line de un buffer de bytes
			Byte [] Bufer2 = System.Text.Encoding.ASCII.GetBytes(CadenaTexto);
			Console.Write("Bufer2 = ");
			for (i=0; i<Bufer2.Length; i++) 
				Console.Write("{0}",Bufer2[i]);
			Console.WriteLine();
			Console.WriteLine("\n\nPresiona ENTER para continuar");
			Console.Read();Console.Read();
		}
	}
}

