using System;
using System.Net;
using System.Net.Sockets;
using System.Text;
namespace ej2_clientesocket
{
	/// <summary>
	/// Descripcin breve de Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// Punto de entrada principal de la aplicacin.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			//
			// TODO: agregar aqu cdigo para iniciar la aplicacin
			//

			String CadenaEnviada, CadenaRecibida;
			int BytesEnviados, BytesRecibidos;
			  
			// Buferes de envio y recepcion (Arrays de Bytes)
			Byte [] BuferEnvia = new Byte[100]; 
			Byte [] BuferRecibe = new Byte[100]; 
			  
			// Especifica la direccion del servidor al que debe conectarse
			IPAddress DireccionRemota = IPAddress.Parse("127.0.0.1");
			Console.WriteLine("Direccion: {0}\n", DireccionRemota.ToString());
			  
			// Especifica un Punto Final de conexion (Direccion + Puerto)
			IPEndPoint ExtremoServidor = new IPEndPoint(DireccionRemota,12345);
			  
			Console.WriteLine("ExtremoServidor.Address: {0}", ExtremoServidor.Address);
			Console.WriteLine("ExtremoServidor.AddressFamily: {0}", ExtremoServidor.AddressFamily);
			Console.WriteLine("ExtremoServidor.Port: {0}", ExtremoServidor.Port);
			Console.WriteLine("\nPuntoFinal: {0}", ExtremoServidor);
			  
			Socket s_datos = new Socket(AddressFamily.InterNetwork,	SocketType.Stream,ProtocolType.IP);

			// Conexion con el servidor
			s_datos.Connect(ExtremoServidor);

			// Enviar peticion al servidor
			CadenaEnviada = "Esto es una prueba";
			BuferEnvia = Encoding.ASCII.GetBytes(CadenaEnviada);
			BytesEnviados = s_datos.Send(BuferEnvia);

			Console.Write(BytesEnviados);
			Console.Write(" Bytes enviados --> ");
			Console.WriteLine(CadenaEnviada);

			// Recibir respuesta del servidor
			BytesRecibidos = s_datos.Receive(BuferRecibe); //printf("%s\n",BuferRecibe);
			CadenaRecibida = Encoding.ASCII.GetString(BuferRecibe);
			Console.Write(BytesRecibidos);
			Console.Write(" Bytes recibidos <-- ");
			Console.WriteLine(CadenaRecibida);

			// Cerrar la conexion y el socket
			s_datos.Shutdown(SocketShutdown.Both);
			s_datos.Close();

		}
	}
}
