using System;
using System.Net;
using System.Net.Sockets;
using System.Text;

namespace ej2_servsocket
{
	/// <summary>
	/// Descripcin breve de Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// Punto de entrada principal de la aplicacin.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			//
			// TODO: agregar aqu cdigo para iniciar la aplicacin
			//
			
			Socket sd, se; // Se declara un socket de datos y un socket de escucha
			String CadenaRecibida, CadenaEnviada; //Se declaran dos cadenas de caracteres
			int BytesRecibidos, BytesEnviados, NumResp = 0;

			// Buferes de recepcion y envio
			Byte [] BuferRecibe = new Byte[100];
			Byte [] BuferEnvia = new Byte [100];

			// Direccion local y punto final de conexion
			IPAddress DireccionLocal = IPAddress.Parse("127.0.0.1"); //Direccion de bucle
			IPEndPoint ExtremoFinal = new IPEndPoint(DireccionLocal,12345);

			// Crear un socket para escuchar peticiones
			se = new Socket(AddressFamily.InterNetwork,SocketType.Stream,ProtocolType.IP);

			// Registrar el socket y ponerlo escuchar peticiones
			se.Bind(ExtremoFinal); // Se registra el socket
			se.Listen(5); // 5 indica la longitud mxima de la cola de conexiones pendientes
  
			while(true) // Bucle infinito
			{
				Console.WriteLine("\nAceptando una peticion ... ");
				sd = se.Accept(); // Se bloquea en este punto hasta que llegue una peticin
  
				// Recibir peticin
				BytesRecibidos = sd.Receive(BuferRecibe); 
				CadenaRecibida = Encoding.ASCII.GetString(BuferRecibe); 
				Console.Write(BytesRecibidos);
				Console.Write(" Bytes recibidos <-- ");
				Console.WriteLine(CadenaRecibida);
  
				// Enviar respuesta
				NumResp++; CadenaEnviada = NumResp.ToString();
				BuferEnvia = Encoding.ASCII.GetBytes(CadenaEnviada);
				BytesEnviados = sd.Send(BuferEnvia);
				Console.Write(BytesEnviados);
				Console.Write(" Bytes enviados --> ");
				Console.WriteLine(CadenaEnviada);
  
				sd.Close();

			}

		}
	}
}
